/*
  GRANITE DATA SERVICES
  Copyright (C) 2012 GRANITE DATA SERVICES S.A.S.

  This file is part of Granite Data Services.

  Granite Data Services is free software; you can redistribute it and/or modify
  it under the terms of the GNU Library General Public License as published by
  the Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  Granite Data Services is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public License
  for more details.

  You should have received a copy of the GNU Library General Public License
  along with this library; if not, see <http://www.gnu.org/licenses/>.
*/

package org.granite.client.tide.impl;

import org.granite.client.configuration.Configuration;
import org.granite.client.configuration.SimpleConfiguration;
import org.granite.client.tide.EventBus;
import org.granite.client.tide.Platform;
import org.granite.client.tide.data.impl.JavaBeanDataManager;
import org.granite.client.tide.data.spi.DataManager;
import org.granite.client.tide.server.ServerSession;

/**
 * @author William DRAI
 */
public class DefaultPlatform implements Platform {
	
	private DataManager dataManager = new JavaBeanDataManager();
	private EventBus eventBus = new SimpleEventBus();
	
	public void configure(Object instance) {
		if (instance instanceof ServerSession) {
			Configuration configuration = new SimpleConfiguration(null, null);
			
			((ServerSession)instance).setConfiguration(configuration);
		}
	}

	@Override
	public void execute(Runnable runnable) {
		runnable.run();
	}

	@Override
	public DataManager getDataManager() {
		return dataManager;
	}

	@Override
	public EventBus getEventBus() {
		return eventBus;
	}

}
